#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar  5 12:52:59 2021

@author: xofe
"""
import matplotlib.pyplot as plt
from numpy import polyfit, loadtxt
# Importation de la fonction d'ouverture du fichier
from tkinter.filedialog import askopenfilename

# ouvre une fenêtre pour charger le fichier csv issu des pointages NE PAS MODIFIER
nom_fichier = askopenfilename(filetypes=(("Fichier CSV", "*.csv"), ("Fichier Texte",
                                                                    "*.txt"), ("Tous les fichiers", "*.*")), title="Choisir un fichier")
# nom_fichier contient le chemin et le nom du fichier à traiter.
I, U = loadtxt(nom_fichier, skiprows=1, delimiter=";",
               unpack=True, usecols=(0, 1))
# nom_fichier contient le chemin et le nom du fichier à traiter.
# On importe les valeurs de l'intensité de de la tension dans deux listes
I, U = loadtxt(nom_fichier, skiprows=1, delimiter=";",
               unpack=True, usecols=(0, 1))

"""Détermination du modèle avec une fonction de type affine"""
# Caractéristique du type U = a * I + b
parametres = polyfit(I, U, 1)
"""parametres est une liste telle que :
a = parametres[0] et b = parametres[1]"""

print("Caractéristique du générateur")
print(f"Force électromotrice : {parametres[1]:.2e} V")
print(f"Résistance interne : {parametres[0]:.2e} ohms")

# Calcul des valeurs du modèle sur la gamme de mesures de l'intensité

# 100 valeurs de l'intensité entre 0 et Imax
Imod = [i * max(I) / 100 for i in range(100)]
Umod = [parametres[0] * val + parametres[1]
        for val in Imod]  # Calcul de la valeur de la tension avec le modèle

"""Tracé des représentations graphiques
--------------------------------------------------"""

plt.figure(1)
plt.scatter(I, U, marker="+", color="red", label="Mesures")
plt.plot(Imod, Umod, color="blue",
         label=fr"Caractéristique : U = {parametres[1]:.2e} + {parametres[0]:.2e} $\times$ I")
plt.xlabel("I (A)")
plt.ylabel("U (V)")
plt.legend()
plt.show()
plt.ylabel("U (V)")
plt.grid()
plt.legend()
plt.show()
