from tkinter.filedialog import askopenfilename
import matplotlib.pyplot as plt
import numpy as np

# on peut donner le chemin d'accès vers le fichier ou la fonction askopenfilename
name = askopenfilename(filetypes=(("Fichier CSV", "*.csv"), ("Fichier Texte",
                                                             "*.txt"), ("Tous les fichiers", "*.*")), title="Choisir un fichier")

sep = ";"  # caractère séparateur du csv -peut être une virgule, un point-virgule ou une tabulation noté \t
entete = 1  # nombre de lignes d'entete

f = open(name, "r")
# on lit toutes les lignes et on met ça dans une liste -un élément par ligne-
data = f.readlines()
f.close()  # on referme le fichier

# on supprime les lignes d'en-tête qui ne nous intéressent pas
data = data[entete:]

# on construit les listes de valeurs utiles
t = np.array([])
x = np.array([])
y = np.array([])
vx = np.array([])
vy = np.array([])
Dvx = np.array([])
Dvy = np.array([])

for ligne in data:
    # change les virgules en point => format numérique différent sur excel et sur python
    ligne = ligne.replace(",", ".")
    # on sépare les différents élément en utilisant le caractère séparateur défini
    ligne = ligne.strip().split(sep)
    ligne = list(map(float, ligne))  # on converti chaque élément en flottant
    # on rentre les valeurs dans les listes adaptées
    t = np.append(t, ligne[0])
    x = np.append(x, ligne[1])
    y = np.append(y, ligne[2])

dt = t[1] - t[0]  # Détermination de l'intervalle de temps entre deux pointages
# Calcul des coordonnées des vecteurs vitesse
for i in range(len(t) - 1):
    vx = np.append(vx, (x[i+1] - x[i]) / dt)
    vy = np.append(vy, (y[i+1] - y[i]) / dt)

for i in range(len(t) - 2):
    Dvx = np.append(Dvx, vx[i+1] - vx[i])
    Dvy = np.append(Dvy, vy[i+1] - vy[i])

# Tracé des vecteurs : ajuster les valeurs du paramètre scale pour changer la taille des vecteurs
# Plus la valeur est faible, plus le vecteur est long

plt.scatter(x, y, marker="x", color="blue", label="Positions")
v = plt.quiver(x[:-1:], y[:-1:], vx, vy, units="dots",
               color="red", scale=0.02, label="Vecteurs vitesse")
Dv = plt.quiver(x[:-2:], y[:-2:], Dvx, Dvy, units="dots", scale=0.02,
                color="green", label="Vecteurs variation de vitesse")
plt.quiverkey(v, 0.9, 0.75, 1,
              label=r"$1\ \mathrm{m \cdot s^{-1}}$", coordinates="axes")
plt.axis("equal")
plt.legend()
plt.show()
