from tkinter.filedialog import askopenfilename
import matplotlib.pyplot as plt
import numpy as np

# Ouverture en mode graphique d'un fichier de pointage au format CSV
# Ne pas modifier les lignes 7 à 17

name = askopenfilename(filetypes =(("Fichier CSV", "*.csv"),("Fichier Texte","*.txt"),("Tous les fichiers","*.*")),title = "Choisir un fichier")

sep = ";"  # Caractère séparateur du csv (à adapter selon le fihcier csv utilisé, tabulation noté \t) 
entete = 1 # Nombre de lignes d'entete (une ligne en général, à adapter sinon)

f = open(name,"r")
data = f.readlines()  # Lecture de toutes les lignes et inscription dans la liste data
f.close() #on referme le fichier

data = data[ entete : ]  # Suppression de la ligne d'en-tête qui ne nous intéressent pas

#  On construit des listes nécessaires
t = np.array([])
x = np.array([])
y = np.array([])
vx = np.array([])
vy = np.array([])
Dvx = np.array([])
Dvy = np.array([])

# Traitement des données et répartition dans les listes t, x et y
# Ne pas modifier les lignes 31 à 38

for ligne in data:
    ligne = ligne.replace("," , ".")  # Séparateur décimal pour Python '.'
    ligne = ligne.strip().split(sep) # Séparation des donnée
    ligne = list(map(float,ligne)) # Conversion en décimal
    # Répartition dans les listes créées précédemment
    t = np.append(t, ligne[0])
    x = np.append(x, ligne[1])
    y = np.append(y, ligne[2])
    
dt = t[1] - t[0]  # Détermination de l'intervalle de temps entre deux pointages

# Calcul des coordonnées des vecteurs vitesse
"""Complétez les champs indiqués afin de calculer :
    - les coordonnées vx et vy au point n°i d'après la méthode vue en cours
    - les coordonnnées Dvx et Dvy au point n°i d'après la méthode vue en cours"""

# Coordonnées vx et vy du vecteur vitesse
for i in range (len(t) - 1) :
    vx = np.append(vx, (x[i+1] - x[i]) / dt)
    vy = np.append(vy, (y[i+1] - y[i]) / dt)

# Coordonnées Dvx et Dvy du vecteur variation de vitesse
for i in range (len(t) - 2) :
    Dvx = np.append(Dvx, vx[i+1] - vx[i-1])
    Dvy = np.append(Dvy, vy[i+1] - vy[i-1])
    
# Obtention des tracés
# Adapter si besoin les échelles en ajustant la valeur scale
# Plus la valeur scale est faible, plus le vecteur est long et inversement.
plt.scatter(x, y, marker = "x", color = "blue", label = "Positions")  # Place les positions
plt.quiver(x[:-1:], y[:-1:], vx, vy, units = "dots", color = "red", scale = 0.05, label = "Vecteurs vitesse")
plt.quiver(x[:-2:], y[:-2:], Dvx, Dvy, units = "dots", scale = 0.005, color = "green", label = "Vecteurs variation de vitesse")
plt.axis("equal")
plt.show()
plt.legend()