from tkinter.filedialog import askopenfilename
import matplotlib.pyplot as plt
import numpy as np

#on peut donner le chemin d'accès vers le fichier ou la fonction askopenfilename
name = askopenfilename(filetypes =(("Fichier CSV", "*.csv"),("Fichier Texte","*.txt"),("Tous les fichiers","*.*")),title = "Choisir un fichier")

sep = ";" #caractère séparateur du csv -peut être une virgule, un point-virgule ou une tabulation noté \t 
entete = 1 #nombre de lignes d'entete

f = open(name,"r")
data = f.readlines() #on lit toutes les lignes et on met ça dans une liste -un élément par ligne-
f.close() #on referme le fichier

data = data[ entete : ] #on supprime les lignes d'en-tête qui ne nous intéressent pas

#on construit les listes de valeurs utiles
t = np.array([])
x = np.array([])
y = np.array([])
vx = np.array([])
vy = np.array([])
Dvx = np.array([])
Dvy = np.array([])

for ligne in data:
    ligne = ligne.replace("," , ".") #change les virgules en point => format numérique différent sur excel et sur python
    ligne = ligne.strip().split(sep) #on sépare les différents élément en utilisant le caractère séparateur défini
    ligne = list(map(float,ligne)) #on converti chaque élément en flottant
    #on rentre les valeurs dans les listes adaptées
    t = np.append(t, ligne[0])
    x = np.append(x, ligne[1])
    y = np.append(y, ligne[2])
    
dt = t[1] - t[0]  # Détermination de l'intervalle de temps entre deux pointages
# Calcul des coordonnées des vecteurs vitesse
for i in range (1, len(t) - 1) :
    vx = np.append(vx, (x[i+1] - x[i-1]) / (2 * dt))
    vy = np.append(vy, (y[i+1] - y[i-1]) / (2 * dt))

for i in range (1, len(vx) - 1) :
    Dvx = np.append(Dvx, vx[i+1] - vx[i-1])
    Dvy = np.append(Dvy, vy[i+1] - vy[i-1])
    
plt.scatter(x, y, marker = "x", color = "blue", label = "Positions")
plt.quiver(x[1:-1:], y[1:-1:], vx, vy, units = "dots", color = "red", scale = 0.075, label = "Vecteurs vitesse")
plt.quiver(x[2:-2:], y[2:-2:], Dvx, Dvy, units = "dots", scale = 0.01, color = "green", label = "Vecteurs variation de vitesse")
plt.axis("equal")
plt.show()
plt.legend()