from tkinter.filedialog import askopenfilename
import matplotlib.pyplot as plt
import numpy as np

#on peut donner le chemin d'accès vers le fichier ou la fonction askopenfilename
name = askopenfilename(filetypes =(("Fichier CSV", "*.csv"),("Fichier Texte","*.txt"),("Tous les fichiers","*.*")),title = "Choisir un fichier")

sep = ";" #caractère séparateur du csv -peut être une virgule, un point-virgule ou une tabulation noté \t 
entete = 1 #nombre de lignes d'entete

f = open(name,"r")
data = f.readlines() #on lit toutes les lignes et on met ça dans une liste -un élément par ligne-
f.close() #on referme le fichier

data = data[ entete : ] #on supprime les lignes d'en-tête qui ne nous intéressent pas

#on construit les listes de valeurs utiles
t = np.array([])
x = np.array([])
y = np.array([])
vx = np.array([])
vy = np.array([])
v = np.array([])  # Valeur de la vitesse
Ep = np.array([])  # Énergie potentielle
Ec = np.array([])  # Énergie cinétique
Em = np.array([])  # Énergie mécanique

for ligne in data:
    ligne = ligne.replace("," , ".") #change les virgules en point => format numérique différent sur excel et sur python
    ligne = ligne.strip().split(sep) #on sépare les différents élément en utilisant le caractère séparateur défini
    ligne = list(map(float,ligne)) #on converti chaque élément en flottant

    #on rentre les valeurs dans les lites adaptées
    t = np.append(t, ligne[0]) 
    x = np.append(x, ligne[1])
    y = np.append(y, ligne[2])

m = float(input("Entrer la masse du dolide en gramme : ")) / 1000 # Masse de la balle
g = 9.8  # intensité de la pesanteur
dt = t[1] - t[0]  # Détermination de l'intervalle de temps entre deux pointages

# Calcul des coordonnées des vecteurs vitesse

for i in range(1, len(x)-1):
    vx = np.append(vx, (x[i+1] - x[i-1]) / (2 * dt))
    vy = np.append(vy, (y[i+1] - y[i-1]) / (2 * dt))

# Calcul des énergies
    
Ep = m * g * y[1:-1:]
Ec = 0.5 * m * (vx**2 + vy**2)
Em = Ec + Ep
    
# Calcul des coordonnées des vecteurs variation de vitesse

    
plt.close()
plt.plot(t[1:-1:], Ep, "b+-", label = "Énergie potentielle")
plt.plot(t[1:-1:], Ec, "r+-", label = "Énergie cinétique")
plt.plot(t[1:-1:], Em, "g+-", label = "Énergie mécanique")
plt.title("Évolution des énergies au cours du temps")
plt.xlabel("t (s)")
plt.ylabel("J")
plt.grid()
plt.legend()
plt.show()
