# Ce programme permet d'obtenir les variations des énergies potentielle, cinétique
# et mécanique au cours du temps à partir d'un fichier csv contenant les positions
# x et y au cours du temps (obtenu par un pointage sur une vidéo)
# Les zones marquées À COMPLÉTER attendent que vous entriez les valeurs ou expressions correctes.

# IMPORTATION DES BIBLIOTHÈQUES NÉCESSAIRES

from tkinter.filedialog import askopenfilename
import matplotlib.pyplot as plt
import numpy as np

# FIN DE L'IMPORTATION DES BIBLIOTHÈQUES

# Ouverture du fichier csv en mode interactif -  NE PAS MODIFIER LES LIGNES 15 À 32
name = askopenfilename(filetypes =(("Fichier CSV", "*.csv"),("Fichier Texte","*.txt"),("Tous les fichiers","*.*")),title = "Choisir un fichier")
sep = ";"  # caractère séparateur du csv -peut être une virgule, un point-virgule ou une tabulation noté \t 
entete = 1  # nombre de lignes d'entete (une dans notre cas)
f = open(name,"r")
data = f.readlines()  # on lit toutes les lignes et on met ça dans une liste -un élément par ligne-
f.close()  # on referme le fichier
data = data[ entete : ]  # on supprime les lignes d'en-tête qui ne nous intéressent pas

#on construit les listes de valeurs utiles
t = np.array([])  # Temps
x = np.array([])  # Abscisses
y = np.array([])  # Ordonnées
vx = np.array([])  # Coordonnées suivant Ox de la vitesse
vy = np.array([])  # Coordonnées suivant Oy de la vitesse
v = np.array([])  # Valeurs de la vitesse
Ep = np.array([])  # Énergie potentielle
Ec = np.array([])  # Énergie cinétique
Em = np.array([])  # Énergie mécanique

# IMPORTATION DES DONNÉES DANS LES LISTES CRÉÉES PRÉCÉDEMMENT - NE PAS MODIFIER
for ligne in data:
    ligne = ligne.replace("," , ".")  # change les virgules en point => séparateur décimal correct en Python
    ligne = ligne.strip().split(sep)  # on sépare les différents élément en utilisant le caractère séparateur défini
    ligne = list(map(float,ligne))  # on converti chaque élément en décimal

    #  Remplissage des listes t, x et y à partir des données importées
    t = np.append(t, ligne[0]) 
    x = np.append(x, ligne[1])
    y = np.append(y, ligne[2])
# FIN D'IMPORTATION DES DONNÉES
    
m = float(input("Entrer la masse de l'objet en grammes : ")) / 1000  # Saisie et conversion de la masse de l'objet au clavier dans la console Python
g = 9.8  # intensité de la pesanteur
dt = t[1] - t[0]  # Détermination de l'intervalle de temps entre deux pointages

# Calcul des coordonnées des vecteurs vitesse et de la valeur de la vitesse

for i in range(len(t)-1):
    vx = np.append(vx, """À COMPLÉTER""")
    vy = np.append(vy, """À COMPLÉTER""")
    
v = """Calcul de la valeur de la vitesse à partir des coordonnées vx et vy"""

"""Calcul des énergies
ATTENTION À LA LONGUEUR DES LISTES : LE CALCUL DE LA VITESSE FAIT PERDRE LE DERNIER TERME
SYNTAXE POUR NE PAS PRENDRE EN COMPTE LE DERNIER TERME D'UNE LISTE :
NOM_LISTE[:-1:]"""

    
Ep = """À COMPLÉTER"""
Ec = """À COMPLÉTER"""
Em = """À COMPLÉTER"""
    
# TRACÉ DES REPRÉSENTATIONS GRAPHIQUES - NE PAS MODIFIER
    
plt.close()
plt.plot(t[:-1:], Ep, "b+", label = "Énergie potentielle")
plt.plot(t[:-1:], Ec, "r+", label = "Énergie cinétique")
plt.plot(t[:-1:], Em, "g+", label = "Énergie mécanique")
plt.title("Évolution des énergies au cours du temps")
plt.xlabel("t (s)")
plt.ylabel("Énergies en J")
plt.grid()
plt.legend()
plt.show()