# Ce programme permet d'obtenir les variations des énergies potentielle, cinétique
# et mécanique au cours du temps à partir d'un fichier csv contenant les positions
# x et y au cours du temps (obtenu par un pointage sur une vidéo)
# Les zones marquées À COMPLÉTER attendent que vous entriez les valeurs ou expressions correctes.

# IMPORTATION DES BIBLIOTHÈQUES NÉCESSAIRES
from tkinter.filedialog import askopenfilename
import matplotlib.pyplot as plt
import numpy as np
# FIN DE L'IMPORTATION

# ouvre une fenêtre pour charger le fichier csv issu des pointages NE PAS MODIFIER
nom_fichier = askopenfilename(filetypes =(("Fichier CSV", "*.csv"),("Fichier Texte","*.txt"),("Tous les fichiers","*.*")),title = "Choisir un fichier")

#on construit les listes de valeurs utiles

vx = np.array([])
vy = np.array([])
Ep = np.array([])  # Énergie potentielle
Ec = np.array([])  # Énergie cinétique
Em = np.array([])  # Énergie mécanique

# IMPORTATION DES DONNÉES DANS LES LISTES CRÉÉES PRÉCÉDEMMENT - NE PAS MODIFIER
t, x, y = np.loadtxt(nom_fichier, unpack = True, delimiter = ';',skiprows=1, usecols=(0,1,2))
    
m = float(input("Entrer la masse de l'objet en grammes : ")) / 1000  # Masse de la balle
g = 9.8  # intensité de la pesanteur
dt = t[1] - t[0]  # Détermination de l'intervalle de temps entre deux pointages

# Calcul des coordonnées des vecteurs vitesse

for i in range(1, len(t)-1):
    vx = np.append(vx, (x[i+1] - x[i-1]) /(2 * dt))
    vy = np.append(vy, (y[i+1] - y[i-1]) /(2 * dt))
    
# Calcul des énergies
    
Ep = m * g * y[1:-1]
Ec = 0.5 * m * (vx**2 + vy**2)
Em = Ec + Ep
    
# TRACÉ DES REPRÉSENTATIONS GRAPHIQUES - NE PAS MODIFIER
    
plt.close()
plt.plot(t[1:-1:], Ep, "b+", label = "Énergie potentielle")
plt.plot(t[1:-1:], Ec, "r+", label = "Énergie cinétique")
plt.plot(t[1:-1:], Em, "g+", label = "Énergie mécanique")
plt.title("Évolution des énergies au cours du temps")
plt.xlabel("t (s)")
plt.ylabel("J")
plt.grid()
plt.legend()
plt.show()