#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Oct 16 18:58:18 2019

@author: xofe
"""
"""On crée les listes qui accueilleront les noms des réactifs, les coefficients
stoechiometriques et les quantités de matière initiales.
"""

"""Initialisation des listes utilisées dans le programme"""

import matplotlib.pyplot as plt
import numpy
reactifs = []
produits = []
coeffReactifs = []
coeffProduits = []
qdmReactifs = []
qdmFinReactifs = []
qdmProduits = []
qdmFinProduits = []
xmaxPossibles = []

nr = int(input("Nombre de réactifs : "))
np = int(input("Nombre de produits : "))

for i in range(nr):
    question = "Réactif n°"+str(i+1)+" : "
    reactifs.append(input(question))
    question = "Coefficient stoechiométrique de "+reactifs[i]+" : "
    coeffReactifs.append(int(input(question)))
    question = "Quantité de matière initiale de "+reactifs[i]+" en mole : "
    qdmReactifs.append(float(input(question)))
for i in range(np):
    question = "Produit n°"+str(i+1)+" : "
    produits.append(input(question))
    question = "Coefficient stoechiométrique de "+produits[i]+" : "
    coeffProduits.append(int(input(question)))
    question = "Quantité de matière initiale de "+produits[i]+" en mole : "
    qdmProduits.append(float(input(question)))
"""Détermination de xmax"""

for i in range(nr):
    xmaxPossibles.append(qdmReactifs[i]/coeffReactifs[i])
xmax = min(xmaxPossibles)
reactifLimitant = xmaxPossibles.index(xmax)

"""Détermination des quantités de matière finales"""

for i in range(nr):
    qdmFinReactifs.append(qdmReactifs[i]-coeffReactifs[i]*xmax)
for i in range(np):
    qdmFinProduits.append(qdmProduits[i]+coeffProduits[i]*xmax)

"""Affichage du bilan de la réaction"""

print("Bilan de la réaction")

"""Écriture de la réaction chimique"""

reaction = ""  # Définition d'une chaîne vide pour la réaction

for i in range(nr):
    reaction = reaction+str(coeffReactifs[i])+" "+reactifs[i]+" + "
reaction = reaction[0:len(reaction)-2]
reaction = reaction + "--> "

for i in range(np):
    reaction = reaction + str(coeffProduits[i])+" "+produits[i]+" + "
reaction = reaction[0:len(reaction)-3]
print(reaction)

print("Avancement maximal : xmax=", xmax, " mol")
print("Réactif limitant : ", reactifs[reactifLimitant])
print()
print("Quantités de matière finales")
for i in range(nr):
    print(reactifs[i], " : ", qdmFinReactifs[i], " mol")

for i in range(np):
    print(produits[i], " : ", qdmFinProduits[i], " mol")

"""Tracé des variations des quantités de matière en fonction de l'avancement"""

x = numpy.linspace(0, max(xmaxPossibles), 100)

plt.figure(1)
plt.title("Évolution des quantités de matière en fonction de l'avancement x")
plt.axis([0, max(xmaxPossibles), 0, max(qdmReactifs)])
for i in range(nr):
    plt.plot(x, qdmReactifs[i]-coeffReactifs[i]*x, label=reactifs[i])
for i in range(np):
    plt.plot(x, qdmProduits[i]+coeffProduits[i]*x, label=produits[i])
plt.xlabel('avancement x (mol)')
plt.ylabel('n (mol)')
plt.grid()
plt.legend()
plt.show()