import matplotlib.pyplot as plt
import numpy as np
x = np.array([0])
dx = 0.005
nMethane = np.array([1.])
nDioxygene = np.array([1.25])
nDioxydeC = 0
nEau = 0

while (nMethane[-1] > 0.) and (nDioxygene[-1] > 0.):
    x = np.append(x, x[-1] + dx)
    nMethane = np.append(nMethane, nMethane[0] - x[-1])
    nDioxygene = np.append(nDioxygene, nDioxygene[0] - 2 * x[-1])
    nDioxydeC = np.append(nDioxydeC, x[-1])
    nEau = np.append(nEau, 2 * x[-1])

"""NE PAS MODIFIER LES LIGNES CI-DESSOUS
ELLES SERVENT AU TRACÉ DES VARIATIONS DES QUANTITÉS DE MATIÈRE"""

plt.plot(x, nMethane,label = "Méthane")
plt.plot(x, nDioxygene,label = "Dioxygène")
plt.plot(x, nDioxydeC, label = "Dioxyde de carbone")
plt.plot(x, nEau, label = "Eau")
plt.xlabel("x (mol)")
plt.ylabel("Quantités de matière (mol)")
plt.legend()
plt.grid()
plt.axis([0, x[-1], 0, max(nMethane[0], nDioxygene[0])])
plt.show()