import matplotlib.pyplot as plt
from matplotlib.widgets import Slider


pas = 0.01
n_diiode = [0]
n_thiosulfate = [0]
n_iodure = [0]
n_tetrathionate = [0]
x = [0]


fig , ax = plt.subplots()
plt.subplots_adjust(left=0.25, bottom=0.4)


ax.set_xlim(0, 5)
ax.set_ylim(0, 10)
plt.xlabel('Avancement (mol)')
plt.ylabel('quantités de matière (mol)')
plt.title(r'$I_2+2 S_2O_3^{2-}   \longrightarrow   2 I^-+S_4O_6^{2-}$')


c1, = plt.plot(x , n_diiode , 'royalblue' ,linewidth = 2 , linestyle = '-' ,  label ='diiode')
c2, = plt.plot(x , n_thiosulfate , 'navy' , linewidth = 2 ,linestyle = '-' , label ='thiosulfate')
c3, = plt.plot(x , n_iodure , 'darkorange' , linewidth = 2 , linestyle = '--' , label ='iodure')
c4, = plt.plot(x , n_tetrathionate , 'tomato' , linewidth = 2  ,linestyle = '--' , label ='tétrahionate')

plt.legend()

axcolor = 'lightgoldenrodyellow'
ax_diiode = plt.axes([0.25, 0.25, 0.65, 0.03], facecolor=axcolor)
slide_diiode = Slider(ax_diiode , r'$n_0(I_2)$' , 0 , 10 , valinit = 0 , valstep = 0.1)

ax_thiosulfate = plt.axes([0.25, 0.20, 0.65, 0.03], facecolor=axcolor)
slide_thiosulfate = Slider(ax_thiosulfate , r'$n_0(S_2O_3^{2-})$', 0 , 10 , valinit = 0 , valstep = 0.1)

ax_iodure = plt.axes([0.25, 0.15, 0.65, 0.03], facecolor=axcolor)
slide_iodure = Slider(ax_iodure , r'$n_0(I^-)$' , 0 , 10 , valinit = 0 , valstep = 0.1)

ax_tetrathionate = plt.axes([0.25, 0.1, 0.65, 0.03], facecolor=axcolor)
slide_tetrathionate = Slider(ax_tetrathionate , r'$n_0(S_4O_6^{2-})$' , 0 , 10 , valinit = 0 , valstep = 0.1)



def update(val) :
        
    n_diiode = []
    n_thiosulfate = []
    n_iodure = []
    n_tetrathionate = []
    n_diiode.append(slide_diiode.val)
    n_thiosulfate.append(slide_thiosulfate.val)
    n_iodure.append(slide_iodure.val)
    n_tetrathionate.append(slide_tetrathionate.val)
    
    continuer = True
    x = [0.01]


    while continuer :
        if (n_diiode[0] - x[-1]) < 0 :
            continuer = False
            reactif_limitant = 'diiode'
            xmax = x[-1]
        elif (n_thiosulfate[0] - 2 * x[-1]) < 0 :
            continuer = False
            reactif_limitant = 'thiosulfate'
            xmax = x[-1]
        else :
            n_diiode.append(n_diiode[0] - x[-1])
            n_thiosulfate.append(n_thiosulfate[0] - (2 * x[-1]))
            n_iodure.append(n_iodure[0] + (2 * x[-1]))
            n_tetrathionate.append(n_tetrathionate[0] + x[-1])
            x.append(x[-1] + pas)

    
    c1.set_ydata(n_diiode)
    c1.set_xdata(x)
    c2.set_ydata(n_thiosulfate)
    c2.set_xdata(x)
    c3.set_ydata(n_iodure)
    c3.set_xdata(x)
    c4.set_ydata(n_tetrathionate)
    c4.set_xdata(x)
    
    fig.canvas.draw_idle()
    



slide_diiode.on_changed(update)
slide_thiosulfate.on_changed(update)
slide_iodure.on_changed(update)
slide_tetrathionate.on_changed(update)

plt.show()
