#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Ce programme permet de SIMULER l'évolution des quantités de matière des réactifs
titrant et titré lors d'un dosage. 
On représente leurs variations en fonction du volume de réactif titrant versé.
Tous les paramètres du titrages sont entrés afin d'effectuer la simulation.
"""

import  numpy as np
import matplotlib.pyplot as plt

def avancementMax(a, na, b, nb) :  # On définint une fonction qui détermine l'avancement maximal
    xmax = min(na / a, nb / b)
    return xmax

print("ÉQUATION DE LA RÉACTION SUPPORT DU TITRAGE")
print("a A + b B --> Produits")
print("A est le réactif TITRÉ et B est le réactif TITRANT.")

a = int(input("Entrez le coefficient stoechiométrique du réactif titré : "))
b = int(input("Entrez le coefficient stoechiométrique du réactif titrant : "))
Ctitre = float(input("Entrez la concentration du réactif titré en mol/L : "))
Vtitre = float(input("Entrez le volume de réactif titré prélevé en mL : "))
Ctitrant = float(input("Entrez la concentration du réactif titrant en mol/L : "))

na = []
nb = []
na0 = Ctitre * Vtitre / 1000  # Quantité de matière initiale de réactif titré

"""def Vequiv(a, na, b, Ctitrant) :  # On définit une fonction qui détermine le volume à l'équivalence
    Ve = b * na / (a * Ctitrant)
    return Ve"""

Vtitrant = np.linspace(0, 15., 501)  # On limite les variations du volume de réactif titrant au volume d'une burette de 25 mL

for v in Vtitrant :
    nb0 = Ctitrant * v / 1000.
    xMax = avancementMax(a, na0, b, nb0)
    na.append(na0 - a * xMax)
    nb.append(nb0 - b * xMax)
    
plt.plot(Vtitrant, na, color = "blue", label = "Réactif titré")
plt.plot(Vtitrant, nb, color = "red", label = "Réactif titrant")
plt.title("Évolution des quantités de matière lors d'un titrage")
plt.xlabel("Volume de réactif titrant versé en mL")
plt.ylabel("Quantités de matière en mol")
plt.grid()
plt.legend()
plt.show()