#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Feb 13 14:42:03 2020

@author: xofe
"""
import matplotlib.pyplot as plt
import numpy as np

e = 1.6e-19  # Charge élémentaire en coulombs
nA = int(input("Entrez le nombre de charges élémentaires portées par la particule A : "))
qA = e * nA  # Calcul de la charge en coulombs
k = 9.e9  # constante dans l'expression de la loi de Coulomb
xA = 2000.  # initialisation des coordonnées de la charge hors grille pour saisie
yA = 2000.

while (xA > 0.01) or (xA < -0.01) :
    xA = float(input("Entrez l'abscisse de la charge ponctuelle A, entre -0,01 et 0,01 : "))
    if (xA > 0.01) or (xA < -0.01) :
        print("Coordonnées hors grille, ressaisissez l'abscisse.")
        
while (yA > 0.01) or (yA < -0.01) :
    yA = float(input("Entrez l'ordonnée de la charge ponctuelle B, entre -0,01 et 0,01 : "))
    if (yA > 0.01) or (yA < -0.01) :
        print("Coordonnées hors grille, ressaisissez l'ordonnée.")

# Création d'une grille pour la représentation du champ de vecteurs
X = np.linspace(-0.01, 0.01, 21)
Y = np.linspace(-0.01, 0.01, 21)
XX, YY = np.meshgrid(X, Y)

rA = ((XX - xA)**2 + (YY - yA)**2)**0.5  # Distance entre la charge et le point où on détermine le champ
EAx = k * qA * (XX - xA) / rA**2  # Calcul de la coordonnée x du champ
EAy = k * qA * (YY - yA) / rA**2  # Calcul de la coordonnée y du champ

plt.scatter(XX, YY, marker = "x", color = "k", s = 10, linewidths = 4)  # Matérialisation de la grille
""" Ci-dessous, on représente le champ de vecteurs
Adapter si besoin l'échelle : valeur scale si les vecteurs sont trop longs ou trop courts
Plus la valeur scale est élevée, plus les vecteurs sont courts et inversement."""
plt.quiver(XX, YY, EAx, EAy, units="dots", color = "b", angles = "xy", scale = 0.0004, scale_units = "xy", label = "Champ électrique")
plt.scatter(xA, yA, marker = "o", color = "r", s = 25)  # On place la charge
plt.legend()  # Affichage de la légende
plt.axis("equal")  # Repère orthonormé
plt.show()  # Affichage de la fenêtre graphique