#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Dec  3 16:24:43 2020

@author: xofe
"""
import matplotlib.pyplot as plt
import numpy as np
# Importation de la fonction d'ouverture du fichier
from tkinter.filedialog import askopenfilename

# ouvre une fenêtre pour charger le fichier csv issu des pointages NE PAS MODIFIER
nom_fichier = askopenfilename(filetypes=(("Fichier CSV", "*.csv"), ("Fichier Texte",
                                                                    "*.txt"), ("Tous les fichiers", "*.*")), title="Choisir un fichier")
# nom_fichier contient le chemin et le nom du fichier à traiter.
t, VH = np.loadtxt(nom_fichier, skiprows=1, delimiter=";",
                   unpack=True, usecols=(0, 1))
Vm = 24.2
n0Mg = 9.47e-3
n0H = 0.024
nH2 = [V / 1000 / Vm for V in VH]
x = nH2
nMg = [n0Mg - val for val in x]
nH = [n0H - 2 * val for val in x]
nMgPlus = nH2

plt.figure(1)
plt.title("Évolution du volume de dihydrogène dégagé")
plt.plot(t, VH, "r+", label="Volume de dihydrogène dégagé")
plt.xlabel("t(s)")
plt.ylabel("$V_{H_2}\ (\mathrm{mL})$")
plt.grid()
plt.show()

plt.figure(2)
plt.title("Évolution de l'avancement x au cours du temps")
plt.plot(t, x, color="black")
plt.xlabel("t(s)")
plt.ylabel("x en mol")
plt.grid()
plt.show()

plt.figure(3)
plt.title("Évolution des quantités de matière au cours du temps")
plt.plot(t, nH2, "b+", label=r"$H_2$")
plt.plot(t, nMg, "r+", label=r"$Mg$")
plt.plot(t, nH, "k+", label=r"$H^{+}$")
plt.plot(t, nMgPlus, "gx", label=r"$Mg^{2+}$")
plt.xlabel("t(s)")
plt.ylabel(r"mol")
plt.grid()
plt.legend()
plt.show()
