#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Importation des bibliothèques nécessaires
import matplotlib.pyplot as plt
import numpy as np
# Importation de la fonction d'ouverture du fichier
from tkinter.filedialog import askopenfilename

# ouvre une fenêtre pour charger le fichier csv issu des pointages NE PAS MODIFIER
nom_fichier = askopenfilename(filetypes=(("Fichier CSV", "*.csv"), ("Fichier Texte",
                                                                    "*.txt"), ("Tous les fichiers", "*.*")), title="Choisir un fichier")
# nom_fichier contient le chemin et le nom du fichier à traiter.
"""La ligne ci-dessous importe les données du fichier de mesures et les place
dans deux listes : t et VH (date et volume de dihydrogène dégagé)
ATTENTION : Il faut avoir un fichier de valeurs au format csv avec le . comme séparateur
décimal et le ';' comme séparateur de colonnes"""
t, VH = np.loadtxt(nom_fichier, skiprows=1, delimiter=";",
                   unpack=True, usecols=(0, 1))

# Entrée des quantités initiales et du volume molaire (L/mol)
# Compléter les lignes ci-dessous avec les paramètres et les quantités de matière
# initiales

Vm = À COMPLÉTER
n0Mg = À COMPLÉTER
n0H = À COMPLÉTER

# Calcul des valeurs de l'avancement à partir des volumes mesurés
"""Compléter les lignes ci-dessous en prenant comme modèles celles déjà complétées
afin d'obtenir les listes des quantités de matière de toutes les espèces chimiques"""

x = [V / 1000 / Vm for V in VH]
# Quantité de matière de magnésium en fonction de x
nMg = [n0Mg - val for val in x]
# Quantité de matière dion H+ en fonction de x
nH = [À COMPLÉTER for val in x]
# Calcul de la quantité de matière de dihydrogène à partir de x
nH2 = [À COMPLÉTER for val in x]
# Quantité de matière d'ions Mg2+ en fonction de x
nMgPlus = [À COMPLÉTER for val in x]

"""Tracé des représentations graphiques"""
"""Compléter les lignes ci-dessous avec les noms corrects des listes à placer en 
abscisses et ordonnées en accord avec le titre du graphique"""

plt.figure(1)
plt.title("Évolution du volume de dihydrogène dégagé")
plt.plot(À COMPLÉTER, À COMPLÉTER, "r+", label="Volume de dihydrogène dégagé")
plt.xlabel("t(s)")
plt.ylabel("$V_{H_2}\ (\mathrm{mL})$")
plt.grid()
plt.show()

plt.figure(2)
plt.title("Évolution de l'avancement x au cours du temps")
plt.plot(À COMPLÉTER, À COMPLÉTER, color="black")
plt.xlabel("t(s)")
plt.ylabel("x en mol")
plt.grid()
plt.show()

plt.figure(3)
plt.title("Évolution des quantités de matière au cours du temps")
plt.plot(À COMPLÉTER, À COMPLÉTER, "b+", label=r"$H_2$")
plt.plot(À COMPLÉTER, À COMPLÉTER, "r+", label=r"$Mg$")
plt.plot(À COMPLÉTER, À COMPLÉTER, "k+", label=r"$H^{+}$")
plt.plot(À COMPLÉTER, À COMPLÉTER, "gx", label=r"$Mg^{2+}$")
plt.xlabel("t(s)")
plt.ylabel(r"mol")
plt.grid()
plt.legend()
plt.show()
